C     ****************************************************************** 

C     MAIN CODE FOR MODULAR MODEL --    9/1/87 

C          BY MICHAEL G. MCDONALD AND ARLEN W. HARBAUGH 

C-----VERSION 1638 24JUL1987 MAIN1 

C     ****************************************************************** 

C 

C        SPECIFICATIONS: 

C     ------------------------------------------------------------------ 

      COMMON X(1500000) 

      COMMON /FLWCOM/LAYCON(80) 

      CHARACTER*4 HEADNG,VBNM 

C 

      CHARACTER*40 OUTFILE,BASFILE,BCFFILE,WELFILE,DRNFILE,RIVFILE, 

     1EVTFILE,GHBFILE,RCHFILE,SIPFILE,SORFILE,OCFILE,CBC1FIL,CBC2FIL, 

     1CBC3FIL,CBC4FIL,CBC5FIL,CBC6FIL,CBC7FIL,HEDFILE,DDNFILE 

C 

      DIMENSION HEADNG(32),VBNM(4,20),VBVL(4,20),IUNIT(24) 

      DOUBLE PRECISION DUMMY 

      EQUIVALENCE (DUMMY,X(1)) 

C     ------------------------------------------------------------------ 

C 

C1------SET SIZE OF X ARRAY. REMEMBER TO REDIMENSION X. 

      LENX=1500000 

C 

C2------ASSIGN BASIC INPUT UNIT AND PRINTER UNIT. 

      INBAS=1 

      IOUT=6 

C 

      WRITE(*,51)IOUT 

  51  FORMAT(//1X,'Enter the file name for the ASCII output file, UNIT ' 

     1,I1,': ',\) 

      READ(*,52)OUTFILE 

  52  FORMAT(A40) 

      OPEN(UNIT=IOUT,FILE=OUTFILE,ACCESS='SEQUENTIAL') 

      WRITE(*,53)INBAS 

  53  FORMAT(1X,'Enter the file name for the BASIC package file, UNIT ' 

     1,I1,': ',\) 

      READ(*,52)BASFILE 

      OPEN(UNIT=INBAS,FILE=BASFILE,ACCESS='SEQUENTIAL') 

C 

C 

C3------DEFINE PROBLEM__ROWS,COLUMNS,LAYERS,STRESS PERIODS,PACKAGES 

      CALL BAS1DF(ISUM,HEADNG,NPER,ITMUNI,TOTIM,NCOL,NROW,NLAY, 

     1             NODES,INBAS,IOUT,IUNIT) 

C 

C 

C 

      WRITE(*,54)IUNIT(1) 

  54  FORMAT(1X,'Enter the file name for the BCF package file, UNIT ' 

     1,I2,': ',\) 

      READ(*,52)BCFFILE 

      OPEN(UNIT=IUNIT(1),FILE=BCFFILE,ACCESS='SEQUENTIAL') 

      IF (IUNIT(2).GT.0)THEN 

        WRITE(*,55)IUNIT(2) 

  55    FORMAT(1X,'Enter the file name for the WELL package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)WELFILE 

        OPEN(UNIT=IUNIT(2),FILE=WELFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(3).GT.0)THEN 

        WRITE(*,56)IUNIT(3) 

  56    FORMAT(1X,'Enter the file name for the DRAIN package file, UNIT' 

     1  ,I3,': ',\) 

        READ(*,52)DRNFILE 

        OPEN(UNIT=IUNIT(3),FILE=DRNFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(4).GT.0)THEN 

        WRITE(*,57)IUNIT(4) 

  57    FORMAT(1X,'Enter the file name for the RIVER package file, UNIT' 

     1  ,I3,': ',\) 

        READ(*,52)RIVFILE 

        OPEN(UNIT=IUNIT(4),FILE=RIVFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(5).GT.0)THEN 

        WRITE(*,58)IUNIT(5) 

  58    FORMAT(1X,'Enter the file name for the EVT package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)EVTFILE 

        OPEN(UNIT=IUNIT(5),FILE=EVTFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(7).GT.0)THEN 

        WRITE(*,59)IUNIT(7) 

  59    FORMAT(1X,'Enter the file name for the GHB package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)GHBFILE 

        OPEN(UNIT=IUNIT(7),FILE=GHBFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(8).GT.0)THEN 

        WRITE(*,60)IUNIT(8) 

  60    FORMAT(1X,'Enter the file name for the RECH package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)RCHFILE 

        OPEN(UNIT=IUNIT(8),FILE=RCHFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(9).GT.0)THEN 

        WRITE(*,61)IUNIT(9) 

  61    FORMAT(1X,'Enter the file name for the SIP package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)SIPFILE 

        OPEN(UNIT=IUNIT(9),FILE=SIPFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(11).GT.0)THEN 

        WRITE(*,62)IUNIT(11) 

  62    FORMAT(1X,'Enter the file name for the SOR package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)SORFILE 

        OPEN(UNIT=IUNIT(11),FILE=SORFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

      IF (IUNIT(12).GT.0)THEN 

        WRITE(*,63)IUNIT(12) 

  63    FORMAT(1X,'Enter the file name for the OC package file, UNIT ' 

     1  ,I2,': ',\) 

        READ(*,52)OCFILE 

        OPEN(UNIT=IUNIT(12),FILE=OCFILE,ACCESS='SEQUENTIAL') 

      ENDIF 

C 

C4------ALLOCATE SPACE IN "X" ARRAY. 

      CALL BAS1AL(ISUM,LENX,LCHNEW,LCHOLD,LCIBOU,LCCR,LCCC,LCCV, 

     1              LCHCOF,LCRHS,LCDELR,LCDELC,LCSTRT,LCBUFF,LCIOFL, 

     2              INBAS,ISTRT,NCOL,NROW,NLAY,IOUT) 

      IF(IUNIT(1).GT.0) CALL BCF1AL(ISUM,LENX,LCSC1,LCHY, 

     1     LCBOT,LCTOP,LCSC2,LCTRPY,IUNIT(1),ISS, 

     2     NCOL,NROW,NLAY,IOUT,IBCFCB) 

      IF(IUNIT(2).GT.0) CALL WEL1AL(ISUM,LENX,LCWELL,MXWELL,NWELLS, 

     1                 IUNIT(2),IOUT,IWELCB) 

      IF(IUNIT(3).GT.0) CALL DRN1AL(ISUM,LENX,LCDRAI,NDRAIN,MXDRN, 

     1                 IUNIT(3),IOUT,IDRNCB) 

      IF(IUNIT(8).GT.0) CALL RCH1AL(ISUM,LENX,LCIRCH,LCRECH,NRCHOP, 

     1            NCOL,NROW,IUNIT(8),IOUT,IRCHCB) 

      IF(IUNIT(5).GT.0) CALL EVT1AL(ISUM,LENX,LCIEVT,LCEVTR,LCEXDP, 

     1            LCSURF,NCOL,NROW,NEVTOP,IUNIT(5),IOUT,IEVTCB) 

      IF(IUNIT(4).GT.0) CALL RIV1AL(ISUM,LENX,LCRIVR,MXRIVR,NRIVER, 

     1            IUNIT(4),IOUT,IRIVCB) 

      IF(IUNIT(7).GT.0) CALL GHB1AL(ISUM,LENX,LCBNDS,NBOUND,MXBND, 

     1            IUNIT(7),IOUT,IGHBCB) 

      IF(IUNIT(9).GT.0) CALL SIP1AL(ISUM,LENX,LCEL,LCFL,LCGL,LCV, 

     1          LCHDCG,LCLRCH,LCW,MXITER,NPARM,NCOL,NROW,NLAY, 

     2          IUNIT(9),IOUT) 

      IF(IUNIT(11).GT.0) CALL SOR1AL(ISUM,LENX,LCA,LCRES,LCHDCG,LCLRCH, 

     1           LCIEQP,MXITER,NCOL,NLAY,NSLICE,MBW,IUNIT(11),IOUT) 

C 

C5------IF THE "X" ARRAY IS NOT BIG ENOUGH THEN STOP. 

      IF(ISUM-1.GT.LENX) STOP 

C 

C6------READ AND PREPARE INFORMATION FOR ENTIRE SIMULATION. 

      CALL BAS1RP(X(LCIBOU),X(LCHNEW),X(LCSTRT),X(LCHOLD), 

     1       ISTRT,INBAS,HEADNG,NCOL,NROW,NLAY,NODES,VBVL,X(LCIOFL), 

     2       IUNIT(12),IHEDFM,IDDNFM,IHEDUN,IDDNUN,IOUT) 

      IF(IUNIT(1).GT.0) CALL BCF1RP(X(LCIBOU),X(LCHNEW),X(LCSC1), 

     1          X(LCHY),X(LCCR),X(LCCC),X(LCCV),X(LCDELR), 

     2           X(LCDELC),X(LCBOT),X(LCTOP),X(LCSC2),X(LCTRPY), 

     3           IUNIT(1),ISS,NCOL,NROW,NLAY,NODES,IOUT) 

      IF(IUNIT(9).GT.0) CALL SIP1RP(NPARM,MXITER,ACCL,HCLOSE,X(LCW), 

     1          IUNIT(9),IPCALC,IPRSIP,IOUT) 

      IF(IUNIT(11).GT.0) CALL SOR1RP(MXITER,ACCL,HCLOSE,IUNIT(11), 

     1         IPRSOR,IOUT) 

C 

C 

      IF(IUNIT(12).GT.0)THEN 

        IF(IHEDUN.GT.0)THEN 

          WRITE(*,71)IHEDUN 

  71      FORMAT(1X,'Enter the file name for binary head output, ' 

     1    ,'UNIT ',I2,': ',\) 

          READ(*,52)HEDFILE 

          OPEN(UNIT=IHEDUN,FILE=HEDFILE,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IDDNUN.GT.0)THEN 

          WRITE(*,72)IDDNUN 

  72      FORMAT(1X,'Enter the file name for binary drawdown output, ' 

     1    ,'UNIT ',I2,': ',\) 

          READ(*,52)DDNFILE 

          OPEN(UNIT=IDDNUN,FILE=DDNFILE,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IBCFCB.GT.0)THEN 

          WRITE(*,64)IBCFCB 

  64      FORMAT(1X,'Enter the file name for the BCF cell-by-cell flux', 

     1    ' terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC1FIL 

          OPEN(UNIT=IBCFCB,FILE=CBC1FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IWELCB.GT.0)THEN 

          WRITE(*,65)IWELCB 

  65      FORMAT(1X,'Enter the file name for the WELL cell-by-cell', 

     1    ' flux terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC2FIL 

          OPEN(UNIT=IWELCB,FILE=CBC2FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IDRNCB.GT.0)THEN 

          WRITE(*,66)IDRNCB 

  66      FORMAT(1X,'Enter the file name for the DRAIN cell-by-cell', 

     1    ' flux terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC3FIL 

          OPEN(UNIT=IDRNCB,FILE=CBC3FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IRIVCB.GT.0)THEN 

          WRITE(*,67)IRIVCB 

  67      FORMAT(1X,'Enter the file name for the RIVER cell-by-cell', 

     1    ' flux terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC4FIL 

          OPEN(UNIT=IRIVCB,FILE=CBC4FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IEVTCB.GT.0)THEN 

          WRITE(*,68)IEVTCB 

  68      FORMAT(1X,'Enter the file name for the EVT cell-by-cell', 

     1    ' flux terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC5FIL 

          OPEN(UNIT=IEVTCB,FILE=CBC5FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IGHBCB.GT.0)THEN 

          WRITE(*,69)IGHBCB 

  69      FORMAT(1X,'Enter the file name for the GHB cell-by-cell', 

     1    ' flux terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC6FIL 

          OPEN(UNIT=IGHBCB,FILE=CBC6FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

        IF(IRCHCB.GT.0)THEN 

          WRITE(*,70)IRCHCB 

  70      FORMAT(1X,'Enter the file name for the RCH cell-by-cell', 

     1    ' flux terms, UNIT ',I2,': ',\) 

          READ(*,52)CBC7FIL 

          OPEN(UNIT=IRCHCB,FILE=CBC7FIL,ACCESS='SEQUENTIAL', 

     1    FORM='UNFORMATTED') 

        ENDIF 

      ENDIF 

C 

C7------SIMULATE EACH STRESS PERIOD. 

      DO 300 KPER=1,NPER 

      KKPER=KPER 

C 

C7A-----READ STRESS PERIOD TIMING INFORMATION. 

      CALL BAS1ST(NSTP,DELT,TSMULT,PERTIM,KKPER,INBAS,IOUT) 

C 

C7B-----READ AND PREPARE INFORMATION FOR STRESS PERIOD. 

      IF(IUNIT(2).GT.0) CALL WEL1RP(X(LCWELL),NWELLS,MXWELL,IUNIT(2), 

     1             IOUT) 

      IF(IUNIT(3).GT.0) CALL DRN1RP(X(LCDRAI),NDRAIN,MXDRN,IUNIT(3), 

     1                 IOUT) 

      IF(IUNIT(8).GT.0) CALL RCH1RP(NRCHOP,X(LCIRCH),X(LCRECH), 

     1            X(LCDELR),X(LCDELC),NROW,NCOL,IUNIT(8),IOUT) 

      IF(IUNIT(5).GT.0) CALL EVT1RP(NEVTOP,X(LCIEVT),X(LCEVTR), 

     1            X(LCEXDP),X(LCSURF),X(LCDELR),X(LCDELC),NCOL,NROW, 

     1            IUNIT(5),IOUT) 

      IF(IUNIT(4).GT.0) CALL RIV1RP(X(LCRIVR),NRIVER,MXRIVR,IUNIT(4), 

     1            IOUT) 

      IF(IUNIT(7).GT.0) CALL GHB1RP(X(LCBNDS),NBOUND,MXBND,IUNIT(7), 

     1              IOUT) 

C 

C7C-----SIMULATE EACH TIME STEP. 

      DO 200 KSTP=1,NSTP 

      KKSTP=KSTP 

C 

C7C1----CALCULATE TIME STEP LENGTH. SET HOLD=HNEW.. 

      CALL BAS1AD(DELT,TSMULT,TOTIM,PERTIM,X(LCHNEW),X(LCHOLD),KKSTP, 

     1             NCOL,NROW,NLAY) 

C 

C7C2----ITERATIVELY FORMULATE AND SOLVE THE EQUATIONS. 

      DO 100 KITER=1,MXITER 

      KKITER=KITER 

C 

C7C2A---FORMULATE THE FINITE DIFFERENCE EQUATIONS. 

      CALL BAS1FM(X(LCHCOF),X(LCRHS),NODES) 

      IF(IUNIT(1).GT.0) CALL BCF1FM(X(LCHCOF),X(LCRHS),X(LCHOLD), 

     1          X(LCSC1),X(LCHNEW),X(LCIBOU),X(LCCR),X(LCCC),X(LCCV), 

     2          X(LCHY),X(LCTRPY),X(LCBOT),X(LCTOP),X(LCSC2), 

     3          X(LCDELR),X(LCDELC),DELT,ISS,KKITER,KKSTP,KKPER,NCOL, 

     4          NROW,NLAY,IOUT) 

      IF(IUNIT(2).GT.0) CALL WEL1FM(NWELLS,MXWELL,X(LCRHS),X(LCWELL), 

     1           X(LCIBOU),NCOL,NROW,NLAY) 

      IF(IUNIT(3).GT.0) CALL DRN1FM(NDRAIN,MXDRN,X(LCDRAI),X(LCHNEW), 

     1         X(LCHCOF),X(LCRHS),X(LCIBOU),NCOL,NROW,NLAY) 

      IF(IUNIT(8).GT.0) CALL RCH1FM(NRCHOP,X(LCIRCH),X(LCRECH), 

     1            X(LCRHS),X(LCIBOU),NCOL,NROW,NLAY) 

      IF(IUNIT(5).GT.0) CALL EVT1FM(NEVTOP,X(LCIEVT),X(LCEVTR), 

     1            X(LCEXDP),X(LCSURF),X(LCRHS),X(LCHCOF),X(LCIBOU), 

     1            X(LCHNEW),NCOL,NROW,NLAY) 

      IF(IUNIT(4).GT.0) CALL RIV1FM(NRIVER,MXRIVR,X(LCRIVR),X(LCHNEW), 

     1            X(LCHCOF),X(LCRHS),X(LCIBOU),NCOL,NROW,NLAY) 

      IF(IUNIT(7).GT.0) CALL GHB1FM(NBOUND,MXBND,X(LCBNDS),X(LCHCOF), 

     1            X(LCRHS),X(LCIBOU),NCOL,NROW,NLAY) 

C 

C7C2B---MAKE ONE CUT AT AN APPROXIMATE SOLUTION. 

      IF(IUNIT(9).GT.0) CALL SIP1AP(X(LCHNEW),X(LCIBOU),X(LCCR),X(LCCC), 

     1     X(LCCV),X(LCHCOF),X(LCRHS),X(LCEL),X(LCFL),X(LCGL),X(LCV), 

     2     X(LCW),X(LCHDCG),X(LCLRCH),NPARM,KKITER,HCLOSE,ACCL,ICNVG, 

     3     KKSTP,KKPER,IPCALC,IPRSIP,MXITER,NSTP,NCOL,NROW,NLAY,NODES, 

     4     IOUT) 

      IF(IUNIT(11).GT.0) CALL SOR1AP(X(LCHNEW),X(LCIBOU),X(LCCR), 

     1     X(LCCC),X(LCCV),X(LCHCOF),X(LCRHS),X(LCA),X(LCRES),X(LCIEQP), 

     2     X(LCHDCG),X(LCLRCH),KKITER,HCLOSE,ACCL,ICNVG,KKSTP,KKPER, 

     3     IPRSOR,MXITER,NSTP,NCOL,NROW,NLAY,NSLICE,MBW,IOUT) 

C 

C7C2C---IF CONVERGENCE CRITERION HAS BEEN MET STOP ITERATING. 

      IF(ICNVG.EQ.1) GO TO 110 

  100 CONTINUE 

      KITER=MXITER 

  110 CONTINUE 

C 

C7C3----DETERMINE WHICH OUTPUT IS NEEDED. 

      CALL BAS1OC(NSTP,KKSTP,ICNVG,X(LCIOFL),NLAY, 

     1  IBUDFL,ICBCFL,IHDDFL,IUNIT(12),IOUT) 

C 

C7C4----CALCULATE BUDGET TERMS. SAVE CELL-BY-CELL FLOW TERMS. 

      MSUM=1 

      IF(IUNIT(1).GT.0) CALL BCF1BD(VBNM,VBVL,MSUM,X(LCHNEW), 

     1     X(LCIBOU),X(LCHOLD),X(LCSC1),X(LCCR),X(LCCC),X(LCCV), 

     2     X(LCTOP),X(LCSC2),DELT,ISS,NCOL,NROW,NLAY,KKSTP,KKPER, 

     3     IBCFCB,ICBCFL,X(LCBUFF),IOUT) 

      IF(IUNIT(2).GT.0) CALL WEL1BD(NWELLS,MXWELL,VBNM,VBVL,MSUM, 

     1     X(LCWELL),X(LCIBOU),DELT,NCOL,NROW,NLAY,KKSTP,KKPER,IWELCB, 

     1     ICBCFL,X(LCBUFF),IOUT) 

      IF(IUNIT(3).GT.0) CALL DRN1BD(NDRAIN,MXDRN,VBNM,VBVL,MSUM, 

     1     X(LCDRAI),DELT,X(LCHNEW),NCOL,NROW,NLAY,X(LCIBOU),KKSTP, 

     2     KKPER,IDRNCB,ICBCFL,X(LCBUFF),IOUT) 

      IF(IUNIT(8).GT.0) CALL RCH1BD(NRCHOP,X(LCIRCH),X(LCRECH), 

     1     X(LCIBOU),NROW,NCOL,NLAY,DELT,VBVL,VBNM,MSUM,KKSTP,KKPER, 

     2     IRCHCB,ICBCFL,X(LCBUFF),IOUT) 

      IF(IUNIT(5).GT.0) CALL EVT1BD(NEVTOP,X(LCIEVT),X(LCEVTR), 

     1     X(LCEXDP),X(LCSURF),X(LCIBOU),X(LCHNEW),NCOL,NROW,NLAY, 

     2     DELT,VBVL,VBNM,MSUM,KKSTP,KKPER,IEVTCB,ICBCFL,X(LCBUFF),IOUT) 

      IF(IUNIT(4).GT.0) CALL RIV1BD(NRIVER,MXRIVR,X(LCRIVR),X(LCIBOU), 

     1     X(LCHNEW),NCOL,NROW,NLAY,DELT,VBVL,VBNM,MSUM, 

     2     KKSTP,KKPER,IRIVCB,ICBCFL,X(LCBUFF),IOUT) 

      IF(IUNIT(7).GT.0) CALL GHB1BD(NBOUND,MXBND,VBNM,VBVL,MSUM, 

     1     X(LCBNDS),DELT,X(LCHNEW),NCOL,NROW,NLAY,X(LCIBOU),KKSTP, 

     2     KKPER,IGHBCB,ICBCFL,X(LCBUFF),IOUT) 

C 

C7C5---PRINT AND OR SAVE HEADS AND DRAWDOWNS. PRINT OVERALL BUDGET. 

      CALL BAS1OT(X(LCHNEW),X(LCSTRT),ISTRT,X(LCBUFF),X(LCIOFL), 

     1        MSUM,X(LCIBOU),VBNM,VBVL,KKSTP,KKPER,DELT, 

     2        PERTIM,TOTIM,ITMUNI,NCOL,NROW,NLAY,ICNVG, 

     3     IHDDFL,IBUDFL,IHEDFM,IHEDUN,IDDNFM,IDDNUN,IOUT) 

C 

C7C6----IF ITERATION FAILED TO CONVERGE THEN STOP. 

      IF(ICNVG.EQ.0) STOP 

  200 CONTINUE 

  300 CONTINUE 

C 

C8------END PROGRAM 

      STOP 

C 

      END 

